import React, { Component } from "react";
import Taro from "@tarojs/taro";
import { Text, View } from "@tarojs/components";
import { AtSearchBar, AtListItem, AtButton, AtIcon } from "taro-ui";
import { getUserByName, getOrderByUid } from "../../utils/servers/servers";
import "taro-ui/dist/style/components/search-bar.scss";
import "taro-ui/dist/style/components/button.scss";
import "taro-ui/dist/style/components/icon.scss";
import "taro-ui/dist/style/components/list.scss";
import "taro-ui/dist/style/components/icon.scss";
import ListBottomStart from "../../components/common/listBottomStart";

// import "../drafts/index.less";

class DataIndex extends Component {
  constructor(props) {
    super(props);
    this.state = {
      value: "",
      list: [],
      listState: "NO_DATA",
      pageNo: 1,
      listVisible: false,
    };
    this.onChange = this.onChange.bind(this);
    this.getList = this.getList.bind(this);
  }

  componentDidMount() {
    // Taro.eventCenter.on("result", () => {
    //   this.setState({
    //     value: "",
    //     list: [],
    //     newList: [],
    //     listState: "NO_DATA",
    //     pageNo: 1,
    //   });
    // });
    // Taro.eventCenter.on("applyDepartSearchList", () => {
    //   this.getList(this.state.value, this.state.pageNo + 1);
    // });
  }

  onReachBottom() {
    this.getList(this.state.value, this.state.pageNo + 1);
  }

  onChange(value, lv = true) {
    this.setState({
      value,
    });
    if (value.length < 2 && !lv) {
      Taro.showToast({ title: "最少输入两个字符", icon: "none" });
      return;
    }
    if (value.length < 4 && lv) {
      return;
    }
    this.getList(value);
  }

  getByUid(val) {
    this.setState({
      listState: "LOADING",
    });
    getOrderByUid({
      uid: val.id,
    }).then((msg) => {
      if (msg.error.length === 0) {
        let data = msg.data;
        this.setState({
          listState: "NO_MORE_DATA",
          orderNo: data,
          listVisible: true,
          listValue: val,
        });
      } else {
        Taro.showToast({ title: msg.error[0].message, icon: "none" });
        this.setState({
          listState: msg.error[0].field === "403" ? "NO_DATA" : "RELOAD",
        });
      }
    });
  }

  getList(value = this.state.value, pageNo = 1) {
    this.setState({
      listState: "LOADING",
    });
    getUserByName({
      name: value,
      type: 1,
      pageNo: pageNo,
      pageSize: 20,
    })
      .then((msg) => {
        if (msg.error.length === 0) {
          if (msg.data.totalCount === 0) {
            this.setState({
              listState: "NO_DATA",
            });
          } else if (
            msg.data.totalCount === this.state.list.length &&
            pageNo !== 1
          ) {
            Taro.showToast({ title: "没有更多数据了", icon: "none" });
            this.setState({
              listState: "NO_MORE_DATA",
            });
          } else {
            if (
              msg.data.totalCount ===
              (pageNo === 1
                ? msg.data.list
                : this.state.list.concat(msg.data.list)
              ).length
            ) {
              this.setState({
                listState: "NO_MORE_DATA",
              });
            }
          }
          this.setState({
            list:
              pageNo === 1
                ? msg.data.list
                : this.state.list.concat(msg.data.list),
            pageNo: msg.data.pageNo,
          });
        } else {
          Taro.showToast({ title: msg.error[0].message, icon: "none" });
          this.setState({
            listState: msg.error[0].field === "403" ? "NO_DATA" : "RELOAD",
          });
        }
      })
      .catch(() => {
        this.setState({
          listState: "RELOAD",
        });
      });
  }


  render() {
    const { } = this.state
    return (
      <>
        <AtSearchBar
          placeholder="请输入企业名称"
          showActionButton
          value={this.state.value}
          onChange={this.onChange}
          onActionClick={() => {
            this.setState({
              listVisible: false,
            });
            this.onChange(this.state.value, false);
          }}
          onConfirm={() => {
            this.onChange(this.state.value, false);
          }}
          onClear={() => {
            this.setState({
              value: "",
              list: [],
              listState: "NO_DATA",
              pageNo: 1,
              listVisible: false,
            });
          }}
        />
        <View>
          {!this.state.listVisible &&
            this.state.list.map((v, k) => (
              <View key={k}>
                <AtListItem
                  title={v.name}
                  arrow="right"
                  iconInfo={{ size: 25, color: "#000000", value: "bookmark" }}
                  onClick={() => {
                    this.getByUid(v);
                  }}
                />
              </View>
            ))}
          {this.state.listVisible &&
            <View>
              <AtListItem
                title={this.state.listValue.name}
                arrow="right"
                iconInfo={{ size: 25, color: "#000000", value: "bookmark" }}
              />
              <View style={{ marginTop: "10px" }}>
                {this.state.orderNo.length > 0 ? (
                  <View>
                    {this.state.orderNo.map((v, k) => (
                      <View
                        key={k}
                        style={{
                          display: "flex",
                          justifyContent: " center",
                          marginBottom: "20px",
                        }}
                      >
                        编号:<View>{v.contractNo}</View>
                        <View
                          style={{
                            width: "60px",
                            height: "24px",
                            backgroundColor: "#5599FF",
                            borderRadius: "15px",
                            textAlign: "center",
                            lineHeight: "24px",
                            marginLeft: "20px",
                            color: "white",
                          }}
                          circle
                          onClick={() => {
                            let pages = Taro.getCurrentPages();
                            let prevPage = pages[pages.length - 2];
                            prevPage.setData({
                              name: this.state.listValue.name,
                              contractNo: v.contractNo,
                              orderNo: v.orderNo,
                            });
                            Taro.navigateBack({
                              delta: 1
                            })
                          }}
                        >
                          选择
                        </View>
                      </View>
                    ))}{" "}
                    <View style={{ color: "red", textAlign: "center" }}>
                      注:请搜索订单对应的企业名称
                    </View>
                  </View>
                ) : (
                  <View style={{ color: "red", textAlign: "center" }}>
                    该企业暂无订单
                  </View>
                )}
              </View>
            </View>}
          <ListBottomStart
            state={this.state.listState}
            reload={() => {
              this.onChange(this.state.value);
            }}
          />
        </View>
      </>
    );
  }
}

export default DataIndex;
